unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UnitV, StdCtrls, DB, IBCustomDataSet, IBQuery, IBDatabase ;

type
  TForm1 = class(TForm)
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBQuery1: TIBQuery;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label6: TLabel;
    Edit4: TEdit;
    Button1: TButton;
    Memo1: TMemo;
    Button4: TButton;
    Label4: TLabel;
    Edit5: TEdit;
    Button2: TButton;
    Edit6: TEdit;
    Label5: TLabel;
    Button3: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    DatFile : string ;  // f[^t@C
    procedure OpenDatFile(fn:string) ;
    procedure SaveDatFile(fn:string) ;
  public
    { Public 錾 }
    procedure DataBaseConnect ;
    procedure DataBaseDisConnect ;
    function  DataTableCheck(t:string) : Boolean ;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// f[^t@Cǂݍ
procedure TForm1.OpenDatFile(fn:string) ;
var
   F : TextFile ;
   s : string ;
begin
   DBserv := '192.168.1.10:';
   DBfold := 'C:\data\';
   DBname := 'ADDRESS.FDB';

   // ǂݍ
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);

      ReadLn(F, DBserv);
      ReadLn(F, DBfold);
      ReadLn(F, DBname);
      ReadLn(F, s);  Form1.Left  := SInt(s) ;
      ReadLn(F, s);  Form1.Top   := SInt(s) ;

      CloseFile(F);
   except
      CloseFile(F);
   end;
end;

// f[^t@Cۑ
procedure TForm1.SaveDatFile(fn:string) ;
var
   F : TextFile ;
   s : string ;
begin
   try
      AssignFile(F, fn);
      ReWrite(F);

      WriteLn(F, DBserv);
      WriteLn(F, DBfold);
      WriteLn(F, DBname);
      s := IntToStr(Form1.Left);    WriteLn(F, s);
      s := IntToStr(Form1.Top);     WriteLn(F, s);

      CloseFile(F);
   except
      CloseFile(F);
      if FileExists(fn) then DeleteFile(fn);
   end;
end;

// f[^x[Xɐڑ
procedure TForm1.DataBaseConnect ;
begin
   // f[^x[Xڑ
   IBDataBase1.DatabaseName := DBserv + DBfold + DBname ;
   IBDataBase1.Connected := False ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER_NAME=SYSDBA');
   IBDatabase1.Params.Add('PASSWORD=masterkey');
   try
      IBDatabase1.Connected := True ;
   except
      // G[f[^x[Xؒf
      DataBaseDisConnect ;
   end;
end;

// f[^x[Xؒf
procedure TForm1.DataBaseDisConnect ;
begin
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
   IBDatabase1.Connected := False ;
end;

// f[^e[ũ`FbN
function TForm1.DataTableCheck(t:string) : Boolean ;
begin
   ComboBox1.Items.Clear ;
   IBDatabase1.GetTableNames(ComboBox1.Items);
   if ComboBox1.Items.IndexOf(t) >= 0 then
      Result := True
   else
      Result := False ;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
begin
  // vÔtH_擾܂
   AppPath := ExtractFilePath(Application.ExeName) ;
   // f[^t@ĆAvOt@C̊gqu.datvɂ
   DatFile := ChangeFileExt(Application.ExeName,'.dat') ;
   OpenDatFile(DatFile) ;
   if (DBfold = '')or(DBname = '') then exit;
   // f[^x[Xڑ
   DataBaseConnect ;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   // f[^x[Xؒf
   DataBaseDisConnect ;
   //
   SaveDatFile(DatFile) ;
end;

// X֔ԍ
procedure TForm1.Button1Click(Sender: TObject);
var
   z,s : string ;
   i : integer ;
begin
   z := Edit4.Text ;
   if (Trim(z) = '') then exit ;
   if not(IBDatabase1.Connected) then exit ; // ڑ
   if not(DataTableCheck(TABLE1)) then exit ;   // X֔ԍ
   //
   Button1.Enabled := False ;
   Button2.Enabled := False ;
   Button3.Enabled := False ;

   Memo1.Lines.Clear ;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      Add('SELECT * FROM '+TABLE1+' WHERE ZIP LIKE '''+z+'%'';') ;
   end;
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      while not(IBQuery1.Eof) do begin
         if ((GetAsyncKeyState(VK_ESCAPE) and $8000) > 0) then break ;  // ESC:f
         s := 'y' + IBQuery1.Fields[0].AsString + 'z' ;
         for i:=4 to 6 do
            s := s + IBQuery1.Fields[i].AsString ;
         s := s + ' (' ;
         for i:=1 to 3 do
            s := s + IBQuery1.Fields[i].AsString ;
         s := s + ')' ;
         Memo1.Lines.Add(s);
         IBQuery1.Next ;
      end;
   except
      ;
   end;
   IBQuery1.Active := False ;

   Button1.Enabled := True ;
   Button2.Enabled := True ;
   Button3.Enabled := True ;
end;

// Z
procedure TForm1.Button2Click(Sender: TObject);
var
   z,s : string ;
   i : integer ;
begin
   z := Edit5.Text ;
   if (Trim(z) = '') then exit ;
   if (AnsiPos('''',z) > 0)or(AnsiPos('"',z) > 0) then exit ;
   if not(IBDatabase1.Connected) then exit ; // ڑ
   if not(DataTableCheck(TABLE1)) then exit ;   // X֔ԍ
   //
   Button1.Enabled := False ;
   Button2.Enabled := False ;
   Button3.Enabled := False ;

   Memo1.Lines.Clear ;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      Add('SELECT * FROM '+TABLE1) ;
      Add('  WHERE (ADR1 || ADR2 || ADR3) LIKE ''%'+z+'%'';') ;
   end;
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      while not(IBQuery1.Eof) do begin
         if ((GetAsyncKeyState(VK_ESCAPE) and $8000) > 0) then break ;  // ESC:f
         s := 'y' + IBQuery1.Fields[0].AsString + 'z' ;
         for i:=4 to 6 do
            s := s + IBQuery1.Fields[i].AsString ;
         s := s + ' (' ;
         for i:=1 to 3 do
            s := s + IBQuery1.Fields[i].AsString ;
         s := s + ')' ;
         Memo1.Lines.Add(s);
         IBQuery1.Next ;
      end;
   except
      ;
   end;
   IBQuery1.Active := False ;

   Button1.Enabled := True ;
   Button2.Enabled := True ;
   Button3.Enabled := True ;
end;

// ZȌ
procedure TForm1.Button3Click(Sender: TObject);
var
   z,s : string ;
   i : integer ;
begin
   z := ZenToHan(Edit6.Text) ;
   if (Trim(z) = '') then exit ;
   if (AnsiPos('''',z) > 0)or(AnsiPos('"',z) > 0) then exit ;
   if not(IBDatabase1.Connected) then exit ; // ڑ
   if not(DataTableCheck(TABLE1)) then exit ;   // X֔ԍ
   //
   Button1.Enabled := False ;
   Button2.Enabled := False ;
   Button3.Enabled := False ;

   Memo1.Lines.Clear ;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      Add('SELECT * FROM '+TABLE1) ;
      Add('  WHERE (ADK1 || ADK2 || ADK3) LIKE ''%'+z+'%'';') ;
   end;
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      while not(IBQuery1.Eof) do begin
         if ((GetAsyncKeyState(VK_ESCAPE) and $8000) > 0) then break ;  // ESC:f
         s := 'y' + IBQuery1.Fields[0].AsString + 'z' ;
         for i:=4 to 6 do
            s := s + IBQuery1.Fields[i].AsString ;
         s := s + ' (' ;
         for i:=1 to 3 do
            s := s + IBQuery1.Fields[i].AsString ;
         s := s + ')' ;
         Memo1.Lines.Add(s);
         IBQuery1.Next ;
      end;
   except
      ;
   end;
   IBQuery1.Active := False ;

   Button1.Enabled := True ;
   Button2.Enabled := True ;
   Button3.Enabled := True ;
end;

// 
procedure TForm1.Button4Click(Sender: TObject);
begin
   close ;
end;

end.
